<?php

namespace App\Controller\Web;

class ProductController
{
    /**
     * $config.
     *
     * @var array
     */
    protected $config;

    public function __construct()
    {
        $this->config = config('product');
    }

    /**
     * 首頁
     */
    public function index($level_1_class_id=null)
    {
        // dd(config('news'));
        // 分類
        $class = \DB::table($this->config['class_table'])->where([['act', 1], ['del', 0]])->orderBy('class_id', 'asc')->orderBy('no', 'desc')->orderBy('id', 'asc')->get(['id', 'class_id', 'name']);

        $news_class = $class->keyBy('id');
        $news_class_tree = $class->groupBy('class_id');

        // 頁數
        // $page = \Request::query('page', 1);
        // $page_show = 8;

        // 預設
        empty($level_1_class_id) and $level_1_class_id = $news_class_tree[0][0]['id'];

        // // 判斷存在以及檢查是否為正確父子關係
        if (!isset($news_class[$level_1_class_id])) {
            $level_1_class_id = null;
        }

        // Data
        $news = \DB::table($this->config['table'])
                   // ->select('id', 'class_id', 'name', 'date')
		           ->where([['class_id',$level_1_class_id], ['act', 1], ['del', 0]])
		           ->orderBy('no', 'desc')
		           ->orderBy('date', 'desc')
		           ->orderBy('id', 'desc')
		          ->get();
        // $v=($level_1_class_id==1)?"index":"index2";
         $v="index";
        $view = \View::make("web.{$this->config['folder']}.". $v, compact('news', 'news_class', 'news_class_tree', 'level_1_class_id'))->render();

        return \Response::create($view)->send();
    }

    /**
     * 資料內頁
     */
    public function detail($level_1_class_id, $id)
    {
        // // 分類
        $class = \DB::table($this->config['class_table'])->where([['act', 1], ['del', 0]])->orderBy('no', 'desc')->orderBy('id', 'asc')->get(['id', 'class_id', 'name']);

        $news_class = $class->keyBy('id');
        $news_class_tree = $class->groupBy('class_id');

        // Data
        $news = \DB::table($this->config['table'])
		           ->where([['id', $id], ['act', 1], ['del', 0]])
		           ->first();

        // if (!isset($news_class[$level_1_class_id])) {
        //     return redirect(\Session::get('lang').'/'.'news')->withErrors('無此筆資料')->send();
        // } elseif (empty($news) || !($news['class_id'] == $level_1_class_id)) {
        //     return redirect(\Session::get('lang').'/'."news/{$level_1_class_id}")->withErrors('無此筆資料')->send();
        // }

         if (empty($news) ) {
            return redirect(\Session::get('lang').'/'."service/{$level_1_class_id}")->withErrors('無此筆資料')->send();
        }

        $pics=\DB::table($this->config['pics_table'])
                   ->where([['pid', $id], ['del', 0]])
                   ->get();
// dd($pics);
        // $v=($news['class_id']==1)?"detail":"detail2";
         $v="detail";
        $view = \View::make("web.{$this->config['folder']}.".$v, compact('news', 'news_class', 'news_class_tree', 'level_1_class_id','pics'))->render();

        return \Response::create($view)->send();
    }
}